<?php
/*
Plugin Name: Random Featured Post
Plugin URI: http://www.mydollarplan.com/random-featured-post-plugin/
Description: Displays featured posts by randomly selecting a post from a designated category.
Author: Scott @ MyDollarPlan.com
Version: 1.0.1 
Author URI: http://www.mydollarplan.com/random-featured-post-plugin/
*/ 

/*  Copyright 2008  Scott @ MyDollarPlan.com  (email : Scott@MyDollarPlan.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function fp_option_menu() {
	if (function_exists('current_user_can')) {
		if (!current_user_can('manage_options')) return;
	} else {
		global $user_level;
		get_currentuserinfo();
		if ($user_level < 8) return;
	}
	if (function_exists('add_options_page')) {
		add_options_page(__('Featured Post'), __('Featured Post'), 1, __FILE__, 'fp_options_page');
	}
}

add_action('admin_menu', 'fp_option_menu');

$default_options['show_featured'] = '';
$default_options['show_category'] = '0';
$default_options['truncate_post_to'] = '200';
$default_options['div_title'] = 'Featured Post';
$default_options['more_text'] = 'Read more &rarr;';
$default_options['excerpt_off'] = 'N';
add_option('fp_featuredpost', $default_options);

function fp_options_page(){
	global $wpdb;
	if (isset($_POST['update_options'])) {
		$options['show_featured'] = trim($_POST['show_featured'],'{}');
                $options['show_category'] = trim($_POST['show_category'],'{}');
                $options['truncate_post_to'] = trim($_POST['truncate_post_to'],'{}');
                $options['div_title'] = trim($_POST['div_title'],'{}');
		$options['more_text'] = trim($_POST['more_text'],'{}');
		$options['excerpt_off'] = trim($_POST['excerpt_off'],'{}');
		update_option('fp_featuredpost', $options);
		echo '<div class="updated"><p>' . __('Options saved') . '</p></div>';
	} else {
		$options = get_option('fp_featuredpost');
	}
	?>
		<div class="wrap">
		<h2><?php echo __('Featured Post Options'); ?></h2><br />
		<form method="post" action="">
                <table align="left">
                <tr><th align="left"><input type="checkbox" name="show_featured" value="show" <?php if ($options['show_featured'] == 'show') echo 'checked="checked"'; ?> />&nbsp;
                <?php _e('Show Featured Post') ?></th></tr>

                <tr><td><?php _e('Show posts from category ID: ') ?>
                <input type="text" name="show_category" size="4" value="<?php if (is_numeric($options['show_category'])) echo $options['show_category']; ?>" /></td></tr>

		<tr><td><?php _e('Featured Post Box Title: ') ?><input type="text" name="div_title" size="30" value="<?php echo $options['div_title']; ?>" /></td></tr>

                <tr><td><?php _e('Excerpt Options: ') ?><br />
                     &nbsp;&nbsp;&nbsp;<INPUT TYPE=RADIO NAME="excerpt_off" VALUE="N" <?php if ($options['excerpt_off'] != 'Y') echo 'CHECKED'; ?>>Display post excerpt if it exists; otherwise, display truncated post contents.<br />
                     &nbsp;&nbsp;&nbsp;<INPUT TYPE=RADIO NAME="excerpt_off" VALUE="Y" <?php if ($options['excerpt_off'] == 'Y') echo 'CHECKED'; ?>>Always display truncated post contents.<br />
                </td></tr>

                <tr><td><?php _e('Truncate post to ') ?>
                <input type="text" name="truncate_post_to" size="5" value="<?php if (is_numeric($options['truncate_post_to'])) echo $options['truncate_post_to']; ?>" />
                <?php _e(' characters.&nbsp;&nbsp;<small>(Does not apply when post excerpt is displayed.)</small>') ?></td></tr>

		<tr><td><?php _e('Text for "continue to post" link: ') ?>
                <input type="text" name="more_text" size="25" value="<?php echo $options['more_text']; ?>" /></td></tr>

		<tr><td><input type="submit" name="update_options" value="<?php _e('Update') ?>"  style="font-weight:bold;" /></td></tr>
                </table>
		</form>
<br />
<table border="1" align="center">
<?php
   echo '<tr><th align="left">Category</th><th>ID</th></tr>';
   $categories = mysql_query("
	SELECT t.term_id, t.name
	FROM $wpdb->terms t
	LEFT JOIN $wpdb->term_taxonomy tax ON tax.term_id = t.term_id
	WHERE tax.taxonomy = 'category'
	ORDER BY t.name
	", $wpdb->dbh) or die(mysql_error().' on line: '.__LINE__);
	
   if ($categories && mysql_num_rows($categories) > 0) {
	while ($category = mysql_fetch_object($categories)) {
		echo '<tr><td>'.$category->name.'&nbsp;</td><td>'.$category->term_id.'</td></tr>';  
	}
   }	
?>
</table>	
	</div>
	<?php	
}


function show_featured_post($PreFeature = '', $PostFeature = '', $AlwaysShow = false) {
   global $wpdb;

   $myID = 0;
   $options = get_option('fp_featuredpost');
   if (!$AlwaysShow) { if ($options['show_featured'] != 'show') return; }
   if (!is_numeric($options['show_category'])) return;

   if (!is_numeric($options['truncate_post_to'])) {
      $trunc = 200;
   } else {
      $trunc = $options['truncate_post_to'];
   }

   if (empty($options['more_text'])) {
      $more_text = 'Read more &rarr;';
   } else {
      $more_text = $options['more_text'];
   }

   $div_title = $options['div_title'];
   if (empty($div_title)) $div_title = "Featured Post";

   $posts = mysql_query("
		SELECT * FROM $wpdb->posts
		LEFT JOIN $wpdb->term_relationships ON
		($wpdb->posts.ID = $wpdb->term_relationships.object_id)
		LEFT JOIN $wpdb->term_taxonomy ON
		($wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id)
		WHERE $wpdb->posts.post_status = 'publish'
		AND $wpdb->term_taxonomy.taxonomy = 'category'
		AND $wpdb->term_taxonomy.term_id = ".$options['show_category']." ORDER BY RAND()
		LIMIT 1
	", $wpdb->dbh) or die(mysql_error().' on line: '.__LINE__);
	
   if ($posts && mysql_num_rows($posts) > 0) {
	while ($post = mysql_fetch_object($posts)) {
		$myID = $post->ID;
	}
   }

   if ($myID == 0) return;

   $post = get_post($myID);
   $desc = attribute_escape(strip_tags($post->post_excerpt));
   if ((empty($desc)) || ($options['excerpt_off'] == 'Y')) {
      $desc = attribute_escape(strip_tags($post->post_content));
      $str_offset = $trunc;
      if (strlen($desc) > $str_offset) { 
         $xlenint = strpos($desc," ",$str_offset);
         $desc = substr($desc,0,$xlenint)."&nbsp;...";
      }
   }

   echo $PreFeature."\n<div class=\"featuredpost\">\n";
   echo "<h3>".$div_title."</h3>\n";
   echo "<h2><a href=\"".$post->guid."\" title=\"".$post->post_title."\">".$post->post_title."</a></h2>\n";
   echo "<p>".$desc."</p>\n";
   echo "<a href=\"".$post->guid."\" title=\"".$post->post_title."\">".$more_text."</a>\n";
   echo "</div>\n".$PostFeature."\n";
}

?>